rndc
Prev | Manual pages | Next

## Name

rndc — name server control utility

## Synopsis

`rndc` [`-b `source-address``] [`-c `config-file``] [`-k `key-file``] [`-s `server``] [`-p `port``] [`-V`] [`-y `key_id``] {command}

## DESCRIPTION

rndc controls the operation of a name server. It supersedes the ndc utility that was provided in old BIND releases. If rndc is invoked with no command line options or arguments, it prints a short summary of the supported commands and the available options and their arguments.

rndc communicates with the name server over a TCP connection, sending commands authenticated with digital signatures. In the current versions of rndc and named, the only supported authentication algorithm is HMAC-MD5, which uses a shared secret on each end of the connection. This provides TSIG-style authentication for the command request and the name server's response. All commands sent over the channel must be signed by a key_id known to the server.

rndc reads a configuration file to determine how to contact the name server and decide what algorithm and key it should use.

## OPTIONS

-b `source-address`

  Use `source-address` as the source address for the connection to the server. Multiple instances are permitted to allow setting of both the IPv4 and IPv6 source addresses.

-c `config-file`

  Use `config-file` as the configuration file instead of the default, `/etc/rndc.conf`.

-k `key-file`

  Use `key-file` as the key file instead of the default, `/etc/rndc.key`. The key in `/etc/rndc.key` will be used to authenticate commands sent to the server if the `config-file` does not exist.

-s `server`

  `server` is the name or address of the server which matches a server statement in the configuration file for rndc. If no server is supplied on the command line, the host named by the default-server clause in the options statement of the rndc configuration file will be used.

-p `port`

  Send commands to TCP port `port` instead of BIND 9's default control channel port, 953.

-V

  Enable verbose logging.

-y `key_id`

  Use the key `key_id` from the configuration file. `key_id` must be known by named with the same algorithm and secret string in order for control message validation to succeed. If no `key_id` is specified, rndc will first look for a key clause in the server statement of the server being used, or if no server statement is present for that host, then the default-key clause of the options statement. Note that the configuration file contains shared secrets which are used to send authenticated control commands to name servers. It should therefore not have general read or write access.

## COMMANDS

A list of commands supported by rndc can be seen by running rndc without arguments.

Currently supported commands are:

`reload`

  Reload configuration file and zones.

`reload `zone` [`class` [`view`]]`

  Reload the given zone.

`refresh `zone` [`class` [`view`]]`

  Schedule zone maintenance for the given zone.

`retransfer `zone` [`class` [`view`]]`

  Retransfer the given zone from the master.

`freeze [`zone` [`class` [`view`]]]`

  Suspend updates to a dynamic zone. If no zone is specified, then all zones are suspended. This allows manual edits to be made to a zone normally updated by dynamic update. It also causes changes in the journal file to be synced into the master file, and the journal file to be removed. All dynamic update attempts will be refused while the zone is frozen.

`thaw [`zone` [`class` [`view`]]]`

  Enable updates to a frozen dynamic zone. If no zone is specified, then all frozen zones are enabled. This causes the server to reload the zone from disk, and re-enables dynamic updates after the load has completed. After a zone is thawed, dynamic updates will no longer be refused.

`notify `zone` [`class` [`view`]]`

  Resend NOTIFY messages for the zone.

`reconfig`

  Reload the configuration file and load new zones, but do not reload existing zone files even if they have changed. This is faster than a full reload when there is a large number of zones because it avoids the need to examine the modification times of the zones files.

`stats`

  Write server statistics to the statistics file.

`querylog` [on|off]

  Toggle query logging. Query logging can also be enabled by explicitly directing the queries category to a channel in the logging section of `named.conf` or by specifying querylog yes; in the options section of `named.conf`.

`dumpdb [-all|-cache|-zone] [`view ...`]`

  Dump the server's caches (default) and/or zones to the dump file for the specified views. If no view is specified, all views are dumped.

`stop [-p]`

  Stop the server, making sure any recent changes made through dynamic update or IXFR are first saved to the master files of the updated zones. If `-p` is specified named's process id is returned. This allows an external process to determine when named had completed stopping.

`halt [-p]`

  Stop the server immediately. Recent changes made through dynamic update or IXFR are not saved to the master files, but will be rolled forward from the journal files when the server is restarted. If `-p` is specified named's process id is returned. This allows an external process to determine when named had completed halting.

`trace`

  Increment the servers debugging level by one.

`trace `level``

  Sets the server's debugging level to an explicit value.

`notrace`

  Sets the server's debugging level to 0.

`flush`

  Flushes the server's cache.

`flushname` `name` [`view`]

  Flushes the given name from the server's cache.

`status`

  Display status of the server. Note that the number of zones includes the internal bind/CH zone and the default ./IN hint zone if there is not an explicit root zone configured.

`recursing`

  Dump the list of queries named is currently recursing on.

`validation ( on | off | check ) [`view ...`]`

  Enable, disable, or check the current status of DNSSEC validation. Note dnssec-enable also needs to be set to `yes` or `auto` to be effective. It defaults to enabled.

`tsig-list`

  List the names of all TSIG keys currently configured for use by named in each view. The list both statically configured keys and dynamic TKEY-negotiated keys.

`tsig-delete` `keyname` [`view`]

  Delete a given TKEY-negotiated key from the server. (This does not apply to statically configured TSIG keys.)

## LIMITATIONS

There is currently no way to provide the shared secret for a `key_id` without using the configuration file.

Several error messages could be clearer.

## SEE ALSO

rndc.conf(5), rndc-confgen(8), named(8), named.conf(5), ndc(8), BIND 9 Administrator Reference Manual.

## AUTHOR

Internet Systems Consortium

Prev | Up | Next
nsupdate | Home | `rndc.conf`